From 2394682b26ee305270d9ebe7de316c863d10fff3 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Sat, 18 Aug 2012 00:40:52 -0500
Subject: [PATCH] Merged pki-native-tools and pki-java-tools.

The pki-native-tools and pki-java-tools have been merged into
pki-tools and pki-server will depend on it. Since pki-ra and
pki-tps depends on pki-server they automatically depends on
pki-tools as well.

Ticket #295
---
 specs/pki-core.spec | 156 ++++++++++++++++++++++++----------------------------
 specs/pki-ra.spec   |   8 ++-
 specs/pki-tps.spec  |   8 ++-
 3 files changed, 81 insertions(+), 91 deletions(-)

diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 2c4c695bdf31dbcef4e2a8ef05e050873a176233..c3333ae603b3ca1cfe93254852e8ebf9fa2e314a 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -14,7 +14,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.0.0
-Release:          %{?relprefix}24%{?prerel}%{?dist}
+Release:          %{?relprefix}25%{?prerel}%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -119,12 +119,11 @@ PKI Core contains ALL top-level java-based Tomcat PKI components:      \
                                                                        \
   * pki-setup                                                          \
   * pki-symkey                                                         \
-  * pki-native-tools                                                   \
   * pki-util-javadoc                                                   \
-  * pki-java-tools                                                     \
   * pki-java-tools-javadoc                                             \
   * pki-base                                                           \
   * pki-common-javadoc                                                 \
+  * pki-tools                                                   \
   * pki-selinux                                                        \
   * pki-server                                                         \
   * pki-ca                                                             \
@@ -143,7 +142,7 @@ For deployment purposes, PKI Core contains fundamental packages        \
 required by BOTH native-based Apache AND java-based Tomcat             \
 Certificate System instances consisting of the following components:   \
                                                                        \
-  * pki-native-tools                                                   \
+  * pki-tools                                                          \
   * pki-selinux                                                        \
   * pki-setup                                                          \
   * pki-silent (required for IPA deployments; optional otherwise)      \
@@ -153,8 +152,8 @@ required ONLY by ALL java-based Tomcat Certificate System instances:   \
                                                                        \
   * pki-symkey                                                         \
   * pki-base                                                           \
+  * pki-tools                                                          \
   * pki-server                                                         \
-  * pki-java-tools                                                     \
                                                                        \
 PKI Core also includes the following components:                       \
                                                                        \
@@ -221,23 +220,6 @@ This package is a part of the PKI Core used by the Certificate System.
 %{overview}
 
 
-%package -n       pki-native-tools
-Summary:          Certificate System - Native Tools
-Group:            System Environment/Base
-
-Requires:         openldap-clients
-Requires:         nss
-Requires:         nss-tools
-
-%description -n   pki-native-tools
-These platform-dependent PKI executables are used to help make
-Certificate System into a more complete and robust PKI solution.
-
-This package is a part of the PKI Core used by the Certificate System.
-
-%{overview}
-
-
 %package -n       pki-util-javadoc
 Summary:          Certificate System - PKI Utility Framework Javadocs
 Group:            Documentation
@@ -253,30 +235,6 @@ This package is a part of the PKI Core used by the Certificate System.
 %{overview}
 
 
-%package -n       pki-java-tools
-Summary:          Certificate System - PKI Java-Based Tools
-Group:            System Environment/Base
-
-BuildArch:        noarch
-
-Requires:         java >= 1:1.6.0
-Requires:         pki-native-tools = %{version}-%{release}
-Requires:         pki-base = %{version}-%{release}
-%if 0%{?fedora} >= 16
-Requires:         jpackage-utils >= 0:1.7.5-10
-%else
-Requires:         jpackage-utils
-%endif
-
-%description -n   pki-java-tools
-These platform-independent PKI executables are used to help make
-Certificate System into a more complete and robust PKI solution.
-
-This package is a part of the PKI Core used by the Certificate System.
-
-%{overview}
-
-
 %package -n       pki-java-tools-javadoc
 Summary:          Certificate System - PKI Java-Based Tools Javadocs
 Group:            Documentation
@@ -367,6 +325,33 @@ This package is a part of the PKI Core used by the Certificate System.
 %{overview}
 
 
+%package -n       pki-tools
+Summary:          Certificate System - PKI Tools
+Group:            System Environment/Base
+
+Obsoletes:        pki-native-tools < %{version}-%{release}
+Obsoletes:        pki-java-tools < %{version}-%{release}
+
+Requires:         openldap-clients
+Requires:         nss
+Requires:         nss-tools
+Requires:         java >= 1:1.6.0
+Requires:         pki-base = %{version}-%{release}
+%if 0%{?fedora} >= 16
+Requires:         jpackage-utils >= 0:1.7.5-10
+%else
+Requires:         jpackage-utils
+%endif
+
+%description -n   pki-tools
+This package contains PKI executables that can be used to help make
+Certificate System into a more complete and robust PKI solution.
+
+This package is a part of the PKI Core used by the Certificate System.
+
+%{overview}
+
+
 %package -n       pki-server
 Summary:          Certificate System - PKI Server Framework
 Group:            System Environment/Base
@@ -376,6 +361,7 @@ BuildArch:        noarch
 Obsoletes:        pki-deploy < %{version}-%{release}
 
 Requires:         pki-base = %{version}-%{release}
+Requires:         pki-tools = %{version}-%{release}
 Requires:         pki-selinux = %{version}-%{release}
 %if 0%{?fedora} >= 18
 Requires(post):   systemd-units
@@ -1140,7 +1126,41 @@ fi
 %{_libdir}/symkey/
 
 
-%files -n pki-native-tools
+%if %{?_without_javadoc:0}%{!?_without_javadoc:1}
+%files -n pki-util-javadoc
+%defattr(-,root,root,-)
+%{_javadocdir}/pki-util-%{version}/
+%endif
+
+
+%if %{?_without_javadoc:0}%{!?_without_javadoc:1}
+%files -n pki-java-tools-javadoc
+%defattr(-,root,root,-)
+%{_javadocdir}/pki-java-tools-%{version}/
+%endif
+
+
+%files -n pki-base
+%defattr(-,root,root,-)
+%doc base/common/LICENSE
+%dir %{_javadir}/pki
+%{_javadir}/pki/pki-cmsutil-%{version}.jar
+%{_javadir}/pki/pki-cmsutil.jar
+%{_javadir}/pki/pki-nsutil-%{version}.jar
+%{_javadir}/pki/pki-nsutil.jar
+%{_javadir}/pki/pki-certsrv-%{version}.jar
+%{_javadir}/pki/pki-certsrv.jar
+%{_javadir}/pki/pki-client-%{version}.jar
+%{_javadir}/pki/pki-client.jar
+
+%if %{?_without_javadoc:0}%{!?_without_javadoc:1}
+%files -n pki-common-javadoc
+%defattr(-,root,root,-)
+%{_javadocdir}/pki-common-%{version}/
+%endif
+
+
+%files -n pki-tools
 %defattr(-,root,root,-)
 %doc base/native-tools/LICENSE base/native-tools/doc/README
 %{_bindir}/p7tool
@@ -1150,18 +1170,6 @@ fi
 %{_bindir}/tkstool
 %dir %{_datadir}/pki
 %{_datadir}/pki/native-tools/
-
-
-%if %{?_without_javadoc:0}%{!?_without_javadoc:1}
-%files -n pki-util-javadoc
-%defattr(-,root,root,-)
-%{_javadocdir}/pki-util-%{version}/
-%endif
-
-
-%files -n pki-java-tools
-%defattr(-,root,root,-)
-%doc base/java-tools/LICENSE
 %{_bindir}/AtoB
 %{_bindir}/AuditVerify
 %{_bindir}/BtoA
@@ -1186,32 +1194,6 @@ fi
 %{_javadir}/pki/pki-tools.jar
 %{_datadir}/pki/java-tools/
 
-%if %{?_without_javadoc:0}%{!?_without_javadoc:1}
-%files -n pki-java-tools-javadoc
-%defattr(-,root,root,-)
-%{_javadocdir}/pki-java-tools-%{version}/
-%endif
-
-
-%files -n pki-base
-%defattr(-,root,root,-)
-%doc base/common/LICENSE
-%dir %{_javadir}/pki
-%{_javadir}/pki/pki-cmsutil-%{version}.jar
-%{_javadir}/pki/pki-cmsutil.jar
-%{_javadir}/pki/pki-nsutil-%{version}.jar
-%{_javadir}/pki/pki-nsutil.jar
-%{_javadir}/pki/pki-certsrv-%{version}.jar
-%{_javadir}/pki/pki-certsrv.jar
-%{_javadir}/pki/pki-client-%{version}.jar
-%{_javadir}/pki/pki-client.jar
-
-%if %{?_without_javadoc:0}%{!?_without_javadoc:1}
-%files -n pki-common-javadoc
-%defattr(-,root,root,-)
-%{_javadocdir}/pki-common-%{version}/
-%endif
-
 
 %files -n pki-server
 %defattr(-,root,root,-)
@@ -1444,6 +1426,10 @@ fi
 
 
 %changelog
+* Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.25.a1
+- Merged pki-native-tools and pki-java-tools into pki-tools.
+- Modified pki-server to depend on pki-tools.
+
 * Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.24.a1
 - Split pki-common into pki-base and pki-server.
 - Merged pki-util into pki-base.
diff --git a/specs/pki-ra.spec b/specs/pki-ra.spec
index b212007cbd9237e91ec2f0b098928fce0e4d33a2..26483332eef95ec3558fdcb0f801551d5f8c3910 100644
--- a/specs/pki-ra.spec
+++ b/specs/pki-ra.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-ra
 Version:          10.0.0
-Release:          %{?relprefix}4%{?prerel}%{?dist}
+Release:          %{?relprefix}5%{?prerel}%{?dist}
 Summary:          Certificate System - Registration Authority
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -30,7 +30,6 @@ Requires:         mod_nss >= 1.0.8
 Requires:         mod_perl >= 1.99_16
 Requires:         mod_revocator >= 1.0.3
 Requires:         pki-server >= 10.0.0
-Requires:         pki-native-tools >= 10.0.0
 Requires:         pki-ra-theme >= 10.0.0
 Requires:         pki-setup
 Requires:         perl-DBD-SQLite
@@ -67,7 +66,7 @@ For deployment purposes, an RA requires the following components from the PKI
 Core package:
 
   * pki-setup
-  * pki-native-tools
+  * pki-tools
   * pki-selinux
 
 and can also make use of the following optional components from the PKI Core
@@ -244,6 +243,9 @@ fi
 
 
 %changelog
+* Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.5.a1
+- Removed direct dependency on 'pki-native-tools'.
+
 * Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.4.a1
 - Replaced 'pki-deploy' with 'pki-server'.
 
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index 16f88d74e2fe6b48971d6d4e85ae2d980dd4160e..abf7fa3ae99555ffee008fcb8c19969da0be68d4 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-tps
 Version:          10.0.0
-Release:          %{?relprefix}4%{?prerel}%{?dist}
+Release:          %{?relprefix}5%{?prerel}%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
 License:          LGPLv2
@@ -39,7 +39,6 @@ Requires:         mod_revocator
 Requires:         openldap-clients
 Requires:         perl-Mozilla-LDAP
 Requires:         pki-server >= 10.0.0
-Requires:         pki-native-tools >= 10.0.0
 Requires:         pki-setup
 Requires:         pki-tps-theme >= 10.0.0
 
@@ -80,7 +79,7 @@ For deployment purposes, a TPS requires the following components from the \
 PKI Core package:                                                         \
                                                                           \
   * pki-setup                                                             \
-  * pki-native-tools                                                      \
+  * pki-tools                                                      \
   * pki-selinux                                                           \
                                                                           \
 and can also make use of the following optional components from the       \
@@ -279,6 +278,9 @@ fi
 
 
 %changelog
+* Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.5.a1
+- Removed direct dependency on 'pki-native-tools'.
+
 * Mon Aug 20 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.4.a1
 - Replaced 'pki-deploy' with 'pki-server'.
 
-- 
1.7.11.2