From 20ae83bfc7b52d5bc26069609a990d8918ce06dd Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Wed, 11 Dec 2013 22:57:02 -0500
Subject: [PATCH] Fixed table style.

The column headers and the footer in all tables have been modified
to use the proper style.

Ticket #654
---
 base/server/share/webapps/pki/css/pki-ui.css       | 22 ++++++++++++++++++++++
 base/tps-tomcat/shared/webapps/tps/activities.html | 14 +++++++-------
 .../shared/webapps/tps/authenticators.html         |  4 ++--
 base/tps-tomcat/shared/webapps/tps/certs.html      | 18 +++++++++---------
 .../tps-tomcat/shared/webapps/tps/connections.html |  4 ++--
 base/tps-tomcat/shared/webapps/tps/groups.html     |  4 ++--
 base/tps-tomcat/shared/webapps/tps/profiles.html   |  4 ++--
 base/tps-tomcat/shared/webapps/tps/selftests.html  | 10 +++++-----
 base/tps-tomcat/shared/webapps/tps/tokens.html     | 16 ++++++++--------
 base/tps-tomcat/shared/webapps/tps/users.html      |  4 ++--
 10 files changed, 61 insertions(+), 39 deletions(-)

diff --git a/base/server/share/webapps/pki/css/pki-ui.css b/base/server/share/webapps/pki/css/pki-ui.css
index 94b55945137c386420e299b41f4e548fdc818d6f..4d79d531d420faf17ed80f923b06e8ad8cfc8cbd 100644
--- a/base/server/share/webapps/pki/css/pki-ui.css
+++ b/base/server/share/webapps/pki/css/pki-ui.css
@@ -47,3 +47,25 @@ input[readonly="readonly"]:focus {
 input[readonly="readonly"]:enabled:hover {
   border-color: #FFFFFF;
 }
+
+table tfoot tr th {
+  padding: 6px 15px;
+  font-size: 11.5px;
+  text-align: left;
+  font-weight: bold;
+  border: none;
+  border-right: 1px #dcdcdc solid;
+  background-image: linear-gradient(top, #fafafa 0%, #eee 100%);
+  background-image: -o-linear-gradient(top, #fafafa 0%, #eee 100%);
+  background-image: -moz-linear-gradient(top, #fafafa 0%, #eee 100%);
+  background-image: -webkit-linear-gradient(top, #fafafa 0%, #eee 100%);
+  background-image: -ms-linear-gradient(top, #fafafa 0%, #eee 100%);
+  background-image: -webkit-gradient(
+	  linear,
+	  left top,
+	  left bottom,
+	  color-stop(0.0, #fafafa),
+	  color-stop(1,0, #eee)
+  );
+  border-bottom: 1px #cedede solid;
+}
diff --git a/base/tps-tomcat/shared/webapps/tps/activities.html b/base/tps-tomcat/shared/webapps/tps/activities.html
index 583f98426e944f8613895ebde81edddd26124df2..3edda45d289cac8174ae0b754d9d02f8886cb86e 100644
--- a/base/tps-tomcat/shared/webapps/tps/activities.html
+++ b/base/tps-tomcat/shared/webapps/tps/activities.html
@@ -53,13 +53,13 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Activity ID</td>
-        <td>Token ID</td>
-        <td>User ID</td>
-        <td>IP</td>
-        <td>Operation</td>
-        <td>Result</td>
-        <td>Date</td>
+        <th>Activity ID</th>
+        <th>Token ID</th>
+        <th>User ID</th>
+        <th>IP</th>
+        <th>Operation</th>
+        <th>Result</th>
+        <th>Date</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/authenticators.html b/base/tps-tomcat/shared/webapps/tps/authenticators.html
index 244ad110a1e776fa2fa33c6148d700ecc046c637..81e2c53ec6af0c8200d90a4eb328abac97422e91 100644
--- a/base/tps-tomcat/shared/webapps/tps/authenticators.html
+++ b/base/tps-tomcat/shared/webapps/tps/authenticators.html
@@ -52,8 +52,8 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Authenticator ID</td>
-        <td>Status</td>
+        <th>Authenticator ID</th>
+        <th>Status</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/certs.html b/base/tps-tomcat/shared/webapps/tps/certs.html
index 975227daeec6cf38b3bbe5860328b1622872e041..c3a70501c455c3ce65323de32618a63c03affc6f 100644
--- a/base/tps-tomcat/shared/webapps/tps/certs.html
+++ b/base/tps-tomcat/shared/webapps/tps/certs.html
@@ -53,15 +53,15 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Certificate ID</td>
-        <td>Serial Number</td>
-        <td>Subject</td>
-        <td>Token ID</td>
-        <td>User ID</td>
-        <td>Key Type</td>
-        <td>Status</td>
-        <td>Create Time</td>
-        <td>Modify Time</td>
+        <th>Certificate ID</th>
+        <th>Serial Number</th>
+        <th>Subject</th>
+        <th>Token ID</th>
+        <th>User ID</th>
+        <th>Key Type</th>
+        <th>Status</th>
+        <th>Create Time</th>
+        <th>Modify Time</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/connections.html b/base/tps-tomcat/shared/webapps/tps/connections.html
index c9750932eeac5f542acae4a3d8ca9d83370ee1e8..0f26e330110ddecb3cac36792bad785f12e9a782 100644
--- a/base/tps-tomcat/shared/webapps/tps/connections.html
+++ b/base/tps-tomcat/shared/webapps/tps/connections.html
@@ -52,8 +52,8 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Connection ID</td>
-        <td>Status</td>
+        <th>Connection ID</th>
+        <th>Status</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/groups.html b/base/tps-tomcat/shared/webapps/tps/groups.html
index bee0563019b5630105155764256c047899f0e394..ade0b7745b769592eb221376d653d5a2877686ba 100644
--- a/base/tps-tomcat/shared/webapps/tps/groups.html
+++ b/base/tps-tomcat/shared/webapps/tps/groups.html
@@ -52,8 +52,8 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Group ID</td>
-        <td>Description</td>
+        <th>Group ID</th>
+        <th>Description</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/profiles.html b/base/tps-tomcat/shared/webapps/tps/profiles.html
index ad5cd2e18728c556f0def43d43ed7dfed98ccbb5..9f00ac5436d35068df4e78f73fe5c633ee9f96dc 100644
--- a/base/tps-tomcat/shared/webapps/tps/profiles.html
+++ b/base/tps-tomcat/shared/webapps/tps/profiles.html
@@ -53,8 +53,8 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Profile ID</td>
-        <td>Status</td>
+        <th>Profile ID</th>
+        <th>Status</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/selftests.html b/base/tps-tomcat/shared/webapps/tps/selftests.html
index b5abb439d0d927f21405a4af6b256bc150867579..888542ec10da410fa6b75c13e012f4bcba2d890d 100644
--- a/base/tps-tomcat/shared/webapps/tps/selftests.html
+++ b/base/tps-tomcat/shared/webapps/tps/selftests.html
@@ -52,11 +52,11 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Self Test ID</td>
-        <td>Enabled at Statup</td>
-        <td>Critical at Startup</td>
-        <td>Enabled on Demand</td>
-        <td>Critical on Demand</td>
+        <th>Self Test ID</th>
+        <th>Enabled at Statup</th>
+        <th>Critical at Startup</th>
+        <th>Enabled on Demand</th>
+        <th>Critical on Demand</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/tokens.html b/base/tps-tomcat/shared/webapps/tps/tokens.html
index e8318df9edbb2e59cc42e011e432d41e8b528cae..695ddf1df39254b5419849c44b4d310209d2adf5 100644
--- a/base/tps-tomcat/shared/webapps/tps/tokens.html
+++ b/base/tps-tomcat/shared/webapps/tps/tokens.html
@@ -53,14 +53,14 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>Token ID</td>
-        <td>User ID</td>
-        <td>Status</td>
-        <td>Reason</td>
-        <td>Applet ID</td>
-        <td>Key Info</td>
-        <td>Created</td>
-        <td>Modified</td>
+        <th>Token ID</th>
+        <th>User ID</th>
+        <th>Status</th>
+        <th>Reason</th>
+        <th>Applet ID</th>
+        <th>Key Info</th>
+        <th>Created</th>
+        <th>Modified</th>
     </tr>
 </thead>
 <tbody>
diff --git a/base/tps-tomcat/shared/webapps/tps/users.html b/base/tps-tomcat/shared/webapps/tps/users.html
index 28ccf592412da643d37b066d8cb82d49ec74ede2..fdf7e741837fa1f983f150a338ae4e27948f1bc4 100644
--- a/base/tps-tomcat/shared/webapps/tps/users.html
+++ b/base/tps-tomcat/shared/webapps/tps/users.html
@@ -52,8 +52,8 @@ $(function() {
          </th>
     </tr>
     <tr>
-        <td>User ID</td>
-        <td>Full Name</td>
+        <th>User ID</th>
+        <th>Full Name</th>
     </tr>
 </thead>
 <tbody>
-- 
1.8.4.2